import { onMount } from "solid-js";
import L from 'leaflet';
import Embalse from "../interfaces/Embalse";
import Api from "../helpers/Api";

function Viewer() {
  let map: L.Map;

  let embalses: Embalse[] = [];

  onMount(() => {
    map = L.map('map');
    L.tileLayer('https://tile.openstreetmap.org/{z}/{x}/{y}.png', {
      maxZoom: 19,
      attribution: '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>'
    }).addTo(map);

    getEmbalses();
  });

  const getEmbalses = async () => {
    embalses = await Api.embalses();

    embalses.forEach(embalse => {
      L.marker([parseFloat(embalse.x), parseFloat(embalse.y)]).addTo(map);
    });
  }

  return (
    <div class="container">
      <div id="map" style={{
        height: '70vh'
      }}></div>
    </div>
  );
}

export default Viewer;
